@echo off

rem NWN Characters Cleaner.bat
rem 2009-09-10
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

  setlocal EnableDelayedExpansion

  call SetNumberOfArguments.bat %*
  if %NumberOfArguments% gtr 1 goto :usage

  set localVaultPath=""
  call :setLocalVaultPath "%SystemDrive%\NeverwinterNights\NWN\localvault"
  call :setLocalVaultPath "%ProgramFiles%\NeverwinterNights\NWN\localvault"

  if %NumberOfArguments% equ 1 set localVaultPath=%~1

  if exist "%localVaultPath%" goto :clean

  goto :pathNotFound

:clean
  for /R "%localVaultPath%" %%f in (*.bic) do (
    set name=%%~nf
    echo !name! | findstr "[0-9]" > NUL
    set result=!ERRORLEVEL!
    if !result! EQU 1 call :cleanCharacter !name!
  )
  goto :end

:cleanCharacter
  set name=%1
  set baseCharacterPath=%localVaultPath%\%name%1.bic
  set count=2
:cleanCharacterLoop
  set charPath=%localVaultPath%\%name%%count%.bic
  if not exist "%charPath%" goto :cleanCharacterFinish
  move "%charPath%" "%baseCharacterPath%" > NUL
  set /a count+=1
  goto :cleanCharacterLoop
:cleanCharacterFinish
  if not %count% equ 2 (
    echo %name% cleaned.
  )
  goto :EOF

:pathNotFound
  echo Cannot find %localVaultPath%!
  goto :end

:setLocalVaultPath
  set parameter=%~1
  if exist "%localVaultPath%" goto :setLocalVaultPathFinish
  set localVaultPath=%parameter%
:setLocalVaultPathFinish
  goto :EOF

:usage
  echo   Usage:   %~n0%~x0
  echo              or
  echo            %~n0%~x0 "path to NWN localvault"
  goto :end

:end
  pause
